import { isLeap } from ".";
import language from "../language";
const formatDate = function(time, format, lang = "CN") {
  const languageEntiy = language[lang] || {};
  format = format || `${languageEntiy.DEFAULT_DATE_FORMAT} ${languageEntiy.DEFAULT_TIME_FORMAT}`;
  const date = time ? new Date(time) : new Date();
  const year = date.getFullYear();
  const month = date.getMonth() + 1;
  const day = date.getDate();
  const hour = date.getHours();
  const min = date.getMinutes();
  const sec = date.getSeconds();
  const preArr = Array.apply(null, Array(10)).map((elem, index) => "0" + index);
  const newTime = format.replace(/YY/g, year + "").replace(/F/g, hour >= 12 ? "pm" : "am").replace(/ss/g, preArr[sec] || sec + "").replace(/mm/g, preArr[min] || min + "").replace(
    /hh/g,
    hour > 12 && format.includes("F") ? hour - 12 + "" : format.includes("F") ? hour + "" : preArr[hour] || hour + ""
  ).replace(/DD/g, preArr[day] || day + "").replace(
    /MM/g,
    lang === "EN" ? languageEntiy.MONTH[month - 1] : preArr[month] || month + ""
  );
  return newTime;
};
const fillNumber = (val) => val > 9 ? val : "0" + val;
const daysOfMonth = (year) => [
  31,
  28 + isLeap(year),
  31,
  30,
  31,
  30,
  31,
  31,
  30,
  31,
  30,
  31
];
const getDayOfWeek = (year = new Date().getFullYear(), month = new Date().getMonth(), day = 1) => {
  const dayOfMonth = new Date(year, month, day);
  const dayOfWeek = dayOfMonth.getDay();
  return dayOfWeek;
};
function pick(obj, keys, ignoreUndefined) {
  return keys.reduce((ret, key) => {
    if (!ignoreUndefined || obj[key] !== void 0) {
      ret[key] = obj[key];
    }
    return ret;
  }, {});
}
export {
  daysOfMonth,
  fillNumber,
  formatDate,
  getDayOfWeek,
  pick
};
