import { type ExtractPropTypes, type PropType } from 'vue';
import type { DisabledScrollType, LangType, MarkDateType, MarkType, ModelType, PickerType, ThemeColorType, WeekStartType } from './types';
export declare const calendarProps: {
    themeColor: {
        type: PropType<ThemeColorType>;
        default: () => {};
    };
    changeYearFast: BooleanConstructor;
    showArrow: BooleanConstructor;
    showWeekView: BooleanConstructor;
    visible: BooleanConstructor;
    disabledWeekView: BooleanConstructor;
    showAction: {
        type: BooleanConstructor;
        default: true;
    };
    pickerType: {
        type: PropType<PickerType>;
        default: PickerType;
    };
    showTodayButton: {
        type: BooleanConstructor;
        default: true;
    };
    defaultDatetime: {
        type: DateConstructor;
        validator: (val: unknown) => val is Date;
        default: Date | null;
    };
    minDate: {
        type: DateConstructor;
        validator: (val: unknown) => val is Date;
        default: Date | null;
    };
    maxDate: {
        type: DateConstructor;
        validator: (val: unknown) => val is Date;
        default: Date | null;
    };
    format: {
        type: PropType<string>;
        default: string;
    };
    model: {
        type: PropType<ModelType>;
        default: ModelType;
    };
    markType: {
        type: PropType<MarkType>;
        default: MarkType;
    };
    markDate: {
        type: PropType<MarkDateType[]>;
        default: () => never[];
    };
    disabledDate: {
        type: FunctionConstructor;
        default: () => boolean;
    };
    disabledTime: {
        type: FunctionConstructor;
        default: () => boolean;
    };
    lang: {
        type: PropType<LangType>;
        default: LangType;
    };
    scrollChangeDate: {
        type: BooleanConstructor;
        default: true;
    };
    minuteStep: {
        type: NumberConstructor;
        default: number;
    };
    weekStart: {
        type: PropType<WeekStartType>;
        default: WeekStartType;
    };
    disabledScroll: {
        type: PropType<DisabledScrollType>;
        default: () => boolean;
    };
    showNotCurrentMonthDay: {
        type: BooleanConstructor;
        default: true;
    };
    firstDayOfMonthClassName: {
        type: PropType<string>;
        default: string;
    };
    todayClassName: {
        type: PropType<string>;
        default: string;
    };
    checkedDayClassName: {
        type: PropType<string>;
        default: string;
    };
    notCurrentMonthDayClassName: {
        type: PropType<string>;
        default: string;
    };
    disabledClassName: {
        type: PropType<string>;
        default: string;
    };
};
export declare type CalendarPropsType = ExtractPropTypes<typeof calendarProps>;
declare const _default: import("vue").DefineComponent<{
    themeColor: {
        type: PropType<ThemeColorType>;
        default: () => {};
    };
    changeYearFast: BooleanConstructor;
    showArrow: BooleanConstructor;
    showWeekView: BooleanConstructor;
    visible: BooleanConstructor;
    disabledWeekView: BooleanConstructor;
    showAction: {
        type: BooleanConstructor;
        default: true;
    };
    pickerType: {
        type: PropType<PickerType>;
        default: PickerType;
    };
    showTodayButton: {
        type: BooleanConstructor;
        default: true;
    };
    defaultDatetime: {
        type: DateConstructor;
        validator: (val: unknown) => val is Date;
        default: Date | null;
    };
    minDate: {
        type: DateConstructor;
        validator: (val: unknown) => val is Date;
        default: Date | null;
    };
    maxDate: {
        type: DateConstructor;
        validator: (val: unknown) => val is Date;
        default: Date | null;
    };
    format: {
        type: PropType<string>;
        default: string;
    };
    model: {
        type: PropType<ModelType>;
        default: ModelType;
    };
    markType: {
        type: PropType<MarkType>;
        default: MarkType;
    };
    markDate: {
        type: PropType<MarkDateType[]>;
        default: () => never[];
    };
    disabledDate: {
        type: FunctionConstructor;
        default: () => boolean;
    };
    disabledTime: {
        type: FunctionConstructor;
        default: () => boolean;
    };
    lang: {
        type: PropType<LangType>;
        default: LangType;
    };
    scrollChangeDate: {
        type: BooleanConstructor;
        default: true;
    };
    minuteStep: {
        type: NumberConstructor;
        default: number;
    };
    weekStart: {
        type: PropType<WeekStartType>;
        default: WeekStartType;
    };
    disabledScroll: {
        type: PropType<DisabledScrollType>;
        default: () => boolean;
    };
    showNotCurrentMonthDay: {
        type: BooleanConstructor;
        default: true;
    };
    firstDayOfMonthClassName: {
        type: PropType<string>;
        default: string;
    };
    todayClassName: {
        type: PropType<string>;
        default: string;
    };
    checkedDayClassName: {
        type: PropType<string>;
        default: string;
    };
    notCurrentMonthDayClassName: {
        type: PropType<string>;
        default: string;
    };
    disabledClassName: {
        type: PropType<string>;
        default: string;
    };
}, () => JSX.Element | undefined, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, ("update:showWeekView" | "click" | "change" | "slidechange" | "touchstart" | "touchmove" | "touchend" | "update:visible" | "calendarTypeChange" | "confirm")[], "update:showWeekView" | "click" | "change" | "slidechange" | "touchstart" | "touchmove" | "touchend" | "update:visible" | "calendarTypeChange" | "confirm", import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<ExtractPropTypes<{
    themeColor: {
        type: PropType<ThemeColorType>;
        default: () => {};
    };
    changeYearFast: BooleanConstructor;
    showArrow: BooleanConstructor;
    showWeekView: BooleanConstructor;
    visible: BooleanConstructor;
    disabledWeekView: BooleanConstructor;
    showAction: {
        type: BooleanConstructor;
        default: true;
    };
    pickerType: {
        type: PropType<PickerType>;
        default: PickerType;
    };
    showTodayButton: {
        type: BooleanConstructor;
        default: true;
    };
    defaultDatetime: {
        type: DateConstructor;
        validator: (val: unknown) => val is Date;
        default: Date | null;
    };
    minDate: {
        type: DateConstructor;
        validator: (val: unknown) => val is Date;
        default: Date | null;
    };
    maxDate: {
        type: DateConstructor;
        validator: (val: unknown) => val is Date;
        default: Date | null;
    };
    format: {
        type: PropType<string>;
        default: string;
    };
    model: {
        type: PropType<ModelType>;
        default: ModelType;
    };
    markType: {
        type: PropType<MarkType>;
        default: MarkType;
    };
    markDate: {
        type: PropType<MarkDateType[]>;
        default: () => never[];
    };
    disabledDate: {
        type: FunctionConstructor;
        default: () => boolean;
    };
    disabledTime: {
        type: FunctionConstructor;
        default: () => boolean;
    };
    lang: {
        type: PropType<LangType>;
        default: LangType;
    };
    scrollChangeDate: {
        type: BooleanConstructor;
        default: true;
    };
    minuteStep: {
        type: NumberConstructor;
        default: number;
    };
    weekStart: {
        type: PropType<WeekStartType>;
        default: WeekStartType;
    };
    disabledScroll: {
        type: PropType<DisabledScrollType>;
        default: () => boolean;
    };
    showNotCurrentMonthDay: {
        type: BooleanConstructor;
        default: true;
    };
    firstDayOfMonthClassName: {
        type: PropType<string>;
        default: string;
    };
    todayClassName: {
        type: PropType<string>;
        default: string;
    };
    checkedDayClassName: {
        type: PropType<string>;
        default: string;
    };
    notCurrentMonthDayClassName: {
        type: PropType<string>;
        default: string;
    };
    disabledClassName: {
        type: PropType<string>;
        default: string;
    };
}>> & {
    "onUpdate:showWeekView"?: ((...args: any[]) => any) | undefined;
    onClick?: ((...args: any[]) => any) | undefined;
    onChange?: ((...args: any[]) => any) | undefined;
    onSlidechange?: ((...args: any[]) => any) | undefined;
    onTouchstart?: ((...args: any[]) => any) | undefined;
    onTouchmove?: ((...args: any[]) => any) | undefined;
    onTouchend?: ((...args: any[]) => any) | undefined;
    "onUpdate:visible"?: ((...args: any[]) => any) | undefined;
    onCalendarTypeChange?: ((...args: any[]) => any) | undefined;
    onConfirm?: ((...args: any[]) => any) | undefined;
}, {
    showWeekView: boolean;
    disabledWeekView: boolean;
    minDate: Date;
    maxDate: Date;
    markType: MarkType;
    markDate: MarkDateType[];
    disabledDate: Function;
    lang: LangType;
    scrollChangeDate: boolean;
    weekStart: WeekStartType;
    disabledScroll: DisabledScrollType;
    showNotCurrentMonthDay: boolean;
    firstDayOfMonthClassName: string;
    todayClassName: string;
    checkedDayClassName: string;
    notCurrentMonthDayClassName: string;
    disabledClassName: string;
    disabledTime: Function;
    minuteStep: number;
    themeColor: ThemeColorType;
    changeYearFast: boolean;
    showArrow: boolean;
    visible: boolean;
    showAction: boolean;
    pickerType: PickerType;
    showTodayButton: boolean;
    defaultDatetime: Date;
    format: string;
    model: ModelType;
}>;
export default _default;
