var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var stdin_exports = {};
__export(stdin_exports, {
  calendarProps: () => calendarProps,
  default: () => stdin_default
});
module.exports = __toCommonJS(stdin_exports);
var import_vue = require("vue");
var import_vue2 = require("vue");
var import_constant = require("./constant");
var import_utils = require("./utils");
var import_language = __toESM(require("./language"));
var import_hooks = require("./hooks");
var import_CalendarDate = __toESM(require("./CalendarDate"));
var import_CalendarTime = __toESM(require("./CalendarTime"));
var import_CalendarYearMonth = __toESM(require("./CalendarYearMonth"));
const calendarProps = {
  themeColor: {
    type: Object,
    default: () => ({})
  },
  changeYearFast: Boolean,
  showArrow: Boolean,
  showWeekView: Boolean,
  visible: Boolean,
  disabledWeekView: Boolean,
  showAction: import_utils.truthProp,
  pickerType: (0, import_utils.makeStringProp)("datetime"),
  showTodayButton: import_utils.truthProp,
  defaultDatetime: (0, import_utils.makeDateProp)(new Date()),
  minDate: (0, import_utils.makeDateProp)(null),
  maxDate: (0, import_utils.makeDateProp)(null),
  format: (0, import_utils.makeStringProp)(""),
  model: (0, import_utils.makeStringProp)("inline"),
  markType: (0, import_utils.makeStringProp)("dot"),
  markDate: (0, import_utils.makeArrayProp)(),
  disabledDate: {
    type: Function,
    default: () => false
  },
  disabledTime: {
    type: Function,
    default: () => false
  },
  lang: (0, import_utils.makeStringProp)("CN"),
  scrollChangeDate: import_utils.truthProp,
  minuteStep: (0, import_utils.makeNumberProp)(1),
  weekStart: (0, import_utils.makeStringProp)("Sunday"),
  disabledScroll: {
    type: [Boolean, String],
    default: () => false
  },
  showNotCurrentMonthDay: import_utils.truthProp,
  firstDayOfMonthClassName: (0, import_utils.makeStringProp)(""),
  todayClassName: (0, import_utils.makeStringProp)(""),
  checkedDayClassName: (0, import_utils.makeStringProp)(""),
  notCurrentMonthDayClassName: (0, import_utils.makeStringProp)(""),
  disabledClassName: (0, import_utils.makeStringProp)("")
};
var stdin_default = (0, import_vue2.defineComponent)({
  name: "VueHashCalendar",
  props: calendarProps,
  emits: ["update:visible", "update:showWeekView", "calendarTypeChange", "click", "confirm", "change", "slidechange", "touchstart", "touchmove", "touchend"],
  setup(props, {
    emit,
    slots
  }) {
    const defaultDate = {
      year: new Date().getFullYear(),
      month: new Date().getMonth(),
      day: new Date().getDate(),
      hours: new Date().getHours(),
      minutes: new Date().getMinutes()
    };
    const calendarTitleRef = (0, import_vue2.ref)();
    const calendarRef = (0, import_vue2.ref)();
    const language = (0, import_vue2.ref)({});
    const checkedDate = (0, import_vue2.ref)(defaultDate);
    const isShowCalendar = (0, import_vue2.ref)(false);
    const isShowWeek = (0, import_vue2.ref)(false);
    const calendarBodyHeight = (0, import_vue2.ref)(0);
    const calendarTitleHeight = (0, import_vue2.ref)(0);
    const firstTimes = (0, import_vue2.ref)(true);
    const currDateTime = (0, import_vue2.ref)(new Date());
    const yearMonthType = (0, import_vue2.ref)("date");
    language.value = import_language.default[props.lang];
    const isShowDatetimePicker = (0, import_vue2.computed)({
      get() {
        return props.model === "inline" ? true : props.visible;
      },
      set(val) {
        emit("update:visible", val);
      }
    });
    const isShowArrowImg = (0, import_vue2.computed)(() => props.showArrow && props.model === "inline");
    const calendarContentHeight = (0, import_vue2.computed)(() => {
      if (props.pickerType === "time") {
        return 245 + calendarTitleHeight.value;
      }
      return calendarBodyHeight.value + calendarTitleHeight.value;
    });
    const init = () => {
      (0, import_vue2.nextTick)(() => {
        calendarTitleHeight.value = (0, import_hooks.useRect)(calendarTitleRef).height;
      });
    };
    (0, import_hooks.useMountedOrActivated)(init);
    const slideChange = (direction) => {
      emit("slidechange", direction);
    };
    const toggleWeek = () => {
      isShowWeek.value = !isShowWeek.value;
      if (isShowWeek.value)
        slideChange("up");
      else
        slideChange("down");
    };
    const today = () => {
      var _a;
      if (props.disabledDate(new Date()))
        return;
      (_a = calendarRef.value) == null ? void 0 : _a.today();
    };
    const lastMonth = () => {
      var _a;
      (_a = calendarRef.value) == null ? void 0 : _a.getLastMonth();
    };
    const nextMonth = () => {
      var _a;
      (_a = calendarRef.value) == null ? void 0 : _a.getNextMonth();
    };
    const lastWeek = () => {
      var _a, _b;
      (_a = calendarRef.value) == null ? void 0 : _a.getLastMonth();
      (_b = calendarRef.value) == null ? void 0 : _b.changeWeekView({
        isNext: false
      });
    };
    const nextWeek = () => {
      var _a, _b;
      (_a = calendarRef.value) == null ? void 0 : _a.getNextMonth();
      (_b = calendarRef.value) == null ? void 0 : _b.changeWeekView({
        isNext: true
      });
    };
    const dateChange = (date) => {
      date.hours = checkedDate.value.hours;
      date.minutes = checkedDate.value.minutes;
      checkedDate.value = date;
    };
    const dateClick = (date, type) => {
      date.hours = checkedDate.value.hours;
      date.minutes = checkedDate.value.minutes;
      checkedDate.value = date;
      let fDate = new Date(`${checkedDate.value.year}/${checkedDate.value.month + 1}/${checkedDate.value.day} ${checkedDate.value.hours}:${checkedDate.value.minutes}`);
      if (props.format) {
        fDate = (0, import_utils.formatDate)(fDate, props.format, props.lang);
      }
      if (type) {
        switch (type) {
          case "yearRange":
            yearMonthType.value = "year";
            break;
          case "year":
            yearMonthType.value = "month";
            break;
          case "month":
            currDateTime.value = new Date(fDate);
            yearMonthType.value = "date";
            break;
        }
        emit("calendarTypeChange", yearMonthType.value);
      }
      emit("click", fDate);
    };
    const timeChange = (date) => {
      date.year = checkedDate.value.year;
      date.month = checkedDate.value.month;
      date.day = checkedDate.value.day;
      checkedDate.value = date;
    };
    const close = () => {
      isShowDatetimePicker.value = false;
    };
    const confirm = () => {
      let date = new Date(`${checkedDate.value.year}/${checkedDate.value.month + 1}/${checkedDate.value.day} ${checkedDate.value.hours}:${checkedDate.value.minutes}`);
      if (props.format) {
        date = (0, import_utils.formatDate)(date, props.format, props.lang);
      }
      emit("confirm", date);
      if (props.model === "dialog") {
        close();
      }
    };
    const formatDatetime = (time, format) => (0, import_utils.formatDate)(time, format, props.lang);
    const showYearMonthPicker = () => {
      if (!props.changeYearFast)
        return;
      if (yearMonthType.value === "date") {
        yearMonthType.value = "month";
      } else if (yearMonthType.value === "month") {
        yearMonthType.value = "year";
      } else if (yearMonthType.value === "year") {
        yearMonthType.value = "yearRange";
      } else {
        yearMonthType.value = "date";
      }
      emit("calendarTypeChange", yearMonthType.value);
    };
    const showCalendar = () => {
      if (isShowCalendar.value) {
        showYearMonthPicker();
      } else {
        emit("calendarTypeChange", "date");
      }
      isShowCalendar.value = true;
    };
    const showTime = () => {
      isShowCalendar.value = false;
      emit("calendarTypeChange", "time");
      yearMonthType.value = "date";
    };
    const heightChange = (height) => {
      if (!firstTimes.value && props.model === "dialog")
        return;
      calendarBodyHeight.value = height;
      firstTimes.value = false;
    };
    const changeThemeColor = () => {
      const themeColorKeys = Object.keys(props.themeColor || {});
      if (themeColorKeys.length) {
        let cssText = "";
        themeColorKeys.forEach((k) => {
          cssText += `--hash-calendar-${k}: ${props.themeColor[k]};`;
        });
        requestAnimationFrame(() => {
          const calendarEle = document.querySelector(".hash-calendar");
          if (calendarEle) {
            calendarEle.style.cssText = cssText;
          }
        });
      }
    };
    const touchStart = (event) => {
      emit("touchstart", event);
    };
    const touchMove = (event) => {
      emit("touchmove", event);
    };
    const touchEnd = (event) => {
      emit("touchend", event);
    };
    (0, import_vue2.watch)(() => props.themeColor, (val) => {
      val && changeThemeColor();
    }, {
      immediate: true
    });
    (0, import_vue2.watch)(() => props.defaultDatetime, (val) => {
      currDateTime.value = val;
    }, {
      immediate: true
    });
    (0, import_vue2.watch)(() => props.pickerType, (val) => {
      if (val === "time") {
        showTime();
      } else {
        showCalendar();
      }
    }, {
      immediate: true
    });
    (0, import_vue2.watch)(() => props.showAction, (flag) => {
      if (!flag) {
        calendarTitleHeight.value = 0;
      } else {
        (0, import_vue2.nextTick)(() => {
          calendarTitleHeight.value = (0, import_hooks.useRect)(calendarTitleRef).height;
        });
      }
    });
    (0, import_vue2.watch)(checkedDate, () => {
      let date = new Date(`${checkedDate.value.year}/${checkedDate.value.month + 1}/${checkedDate.value.day} ${checkedDate.value.hours}:${checkedDate.value.minutes}`);
      if (props.format) {
        date = (0, import_utils.formatDate)(date, props.format, props.lang);
      }
      emit("change", date);
    }, {
      deep: true
    });
    (0, import_vue2.watch)(() => props.showWeekView, (val) => {
      isShowWeek.value = val;
    }, {
      immediate: true
    });
    (0, import_vue2.watch)(() => props.visible, () => {
      init();
    });
    (0, import_hooks.useExpose)({
      today,
      lastMonth,
      nextMonth,
      lastWeek,
      nextWeek
    });
    const renderTodayButton = () => {
      let todayEle = language.value.TODAY;
      if (slots.today) {
        todayEle = slots.today();
      }
      if (props.showTodayButton) {
        return (0, import_vue.createVNode)("div", {
          "class": `calendar_confirm ${props.disabledDate(new Date()) ? "today_disable" : ""}`,
          "onClick": today
        }, [todayEle]);
      }
    };
    const renderConfirmButton = () => {
      let confirmEle = language.value.CONFIRM;
      if (slots.confirm) {
        confirmEle = slots.confirm();
      }
      if (props.model === "dialog") {
        return (0, import_vue.createVNode)("div", {
          "class": "calendar_confirm",
          "onClick": confirm
        }, [confirmEle]);
      }
    };
    const renderAction = () => {
      if (slots.action) {
        return slots.action();
      }
      if (props.showAction) {
        return (0, import_vue.createVNode)(import_vue.Fragment, null, [(0, import_vue.createVNode)("div", {
          "class": "calendar_title_date"
        }, [props.pickerType !== "time" ? (0, import_vue.createVNode)("span", {
          "class": `calendar_title_date_year ${isShowCalendar.value ? "calendar_title_date_active" : ""}`,
          "onClick": showCalendar
        }, [formatDatetime(`${checkedDate.value.year}/${checkedDate.value.month + 1}/${checkedDate.value.day}`, language.value.DEFAULT_DATE_FORMAT)]) : null, props.pickerType !== "date" ? (0, import_vue.createVNode)("span", {
          "class": `calendar_title_date_time ${!isShowCalendar.value ? "calendar_title_date_active" : ""}`,
          "onClick": showTime
        }, [formatDatetime(`${checkedDate.value.year}/${checkedDate.value.month + 1}/${checkedDate.value.day} ${(0, import_utils.fillNumber)(checkedDate.value.hours)}:${(0, import_utils.fillNumber)(checkedDate.value.minutes)}`, language.value.DEFAULT_TIME_FORMAT)]) : null]), renderTodayButton(), renderConfirmButton()]);
      }
    };
    const renderCalendarTitle = () => (0, import_vue.createVNode)("div", {
      "class": "calendar_title",
      "ref": calendarTitleRef
    }, [renderAction()]);
    const updateShowWeekView = (val) => {
      if (val) {
        emit("calendarTypeChange", "week");
      } else {
        emit("calendarTypeChange", "month");
      }
      isShowWeek.value = val;
    };
    const renderCalendar = () => (0, import_vue.createVNode)(import_CalendarDate.default, (0, import_vue.mergeProps)({
      "ref": calendarRef,
      "show": isShowCalendar.value,
      "calendarTitleHeight": calendarTitleHeight.value,
      "onHeight": heightChange,
      "defaultDate": currDateTime.value,
      "onTouchstart": touchStart,
      "onTouchmove": touchMove,
      "onTouchend": touchEnd,
      "onSlidechange": slideChange,
      "onChange": dateChange,
      "onClick": dateClick,
      "showWeekView": isShowWeek.value,
      "onUpdate:showWeekView": updateShowWeekView
    }, (0, import_utils.pick)(props, ["minDate", "maxDate", "disabledWeekView", "markType", "markDate", "disabledDate", "lang", "weekStart", "disabledScroll", "scrollChangeDate", "showNotCurrentMonthDay", "firstDayOfMonthClassName", "todayClassName", "checkedDayClassName", "notCurrentMonthDayClassName", "disabledClassName"])), (0, import_utils.pick)(slots, ["week", "day"]));
    const renderTimePicker = () => {
      if (props.pickerType !== "date") {
        return (0, import_vue.createVNode)(import_CalendarTime.default, (0, import_vue.mergeProps)({
          "show": !isShowCalendar.value,
          "defaultTime": currDateTime.value,
          "calendarDate": checkedDate.value,
          "onChange": timeChange
        }, (0, import_utils.pick)(props, ["minuteStep", "disabledTime"])), null);
      }
    };
    const renderYearMonthPicker = () => (0, import_vue.createVNode)(import_CalendarYearMonth.default, (0, import_vue.mergeProps)({
      "calendarTitleHeight": calendarTitleHeight.value,
      "calendarContentHeight": calendarContentHeight.value,
      "calendarDate": checkedDate.value,
      "type": yearMonthType.value,
      "onTouchstart": touchStart,
      "onTouchmove": touchMove,
      "onTouchend": touchEnd,
      "onSlidechange": slideChange,
      "onClick": dateClick
    }, (0, import_utils.pick)(props, ["minDate", "maxDate", "disabledDate", "lang", "disabledScroll", "checkedDayClassName", "notCurrentMonthDayClassName", "disabledClassName"])), null);
    const renderCtrlImg = () => {
      let confirmEle = (0, import_vue.createVNode)("img", {
        "src": isShowWeek.value ? import_constant.ARROW_DOWN_IMG : import_constant.ARROW_UP_IMG
      }, null);
      if (slots.arrow) {
        confirmEle = slots.arrow({
          show: isShowWeek.value
        });
      }
      if (isShowArrowImg.value) {
        return (0, import_vue.createVNode)("div", {
          "class": "ctrl-img",
          "onClick": toggleWeek,
          "style": {
            "margin-top": `${calendarContentHeight.value}px`
          }
        }, [confirmEle]);
      }
    };
    const renderHashCalendar = () => {
      if (isShowDatetimePicker.value || props.model === "inline") {
        return (0, import_vue.createVNode)("div", {
          "class": `hash-calendar ${props.model === "inline" ? "calendar_inline" : ""}`,
          "style": {
            height: `${props.model === "inline" ? calendarContentHeight.value + (isShowArrowImg.value ? 30 : 0) : void 0}px`
          },
          "onClick": close
        }, [(0, import_vue.createVNode)("div", {
          "class": "calendar_content",
          "style": {
            height: `${calendarContentHeight.value}px`,
            bottom: `${isShowArrowImg.value ? 30 : 0}px`
          },
          "onClick": (e) => {
            e.preventDefault();
            e.stopImmediatePropagation();
          }
        }, [renderCalendarTitle(), props.pickerType !== "time" ? renderCalendar() : "", renderTimePicker(), props.changeYearFast ? renderYearMonthPicker() : ""]), renderCtrlImg()]);
      }
    };
    return () => renderHashCalendar();
  }
});
