import { type ExtractPropTypes, type PropType } from 'vue';
import { DisabledScrollType, LangType, MarkDateType, MarkType, WeekStartType } from './types';
export declare const calendarDateProps: {
    showWeekView: BooleanConstructor;
    show: BooleanConstructor;
    disabledWeekView: BooleanConstructor;
    defaultDate: {
        type: DateConstructor;
        validator: (val: unknown) => val is Date;
        default: Date | null;
    };
    minDate: {
        type: DateConstructor;
        validator: (val: unknown) => val is Date;
        default: Date | null;
    };
    maxDate: {
        type: DateConstructor;
        validator: (val: unknown) => val is Date;
        default: Date | null;
    };
    markType: {
        type: PropType<MarkType>;
        default: MarkType;
    };
    markDate: {
        type: PropType<MarkDateType[]>;
        default: () => never[];
    };
    disabledDate: {
        type: FunctionConstructor;
        default: () => boolean;
    };
    lang: {
        type: PropType<LangType>;
        default: LangType;
    };
    scrollChangeDate: {
        type: BooleanConstructor;
        default: true;
    };
    calendarTitleHeight: {
        type: NumberConstructor;
        default: number;
    };
    weekStart: {
        type: PropType<WeekStartType>;
        default: WeekStartType;
    };
    disabledScroll: {
        type: PropType<DisabledScrollType>;
        default: () => boolean;
    };
    showNotCurrentMonthDay: {
        type: BooleanConstructor;
        default: true;
    };
    firstDayOfMonthClassName: {
        type: PropType<string>;
        default: string;
    };
    todayClassName: {
        type: PropType<string>;
        default: string;
    };
    checkedDayClassName: {
        type: PropType<string>;
        default: string;
    };
    notCurrentMonthDayClassName: {
        type: PropType<string>;
        default: string;
    };
    disabledClassName: {
        type: PropType<string>;
        default: string;
    };
};
export declare type CalendarDatePropsType = ExtractPropTypes<typeof calendarDateProps>;
declare const _default: import("vue").DefineComponent<{
    showWeekView: BooleanConstructor;
    show: BooleanConstructor;
    disabledWeekView: BooleanConstructor;
    defaultDate: {
        type: DateConstructor;
        validator: (val: unknown) => val is Date;
        default: Date | null;
    };
    minDate: {
        type: DateConstructor;
        validator: (val: unknown) => val is Date;
        default: Date | null;
    };
    maxDate: {
        type: DateConstructor;
        validator: (val: unknown) => val is Date;
        default: Date | null;
    };
    markType: {
        type: PropType<MarkType>;
        default: MarkType;
    };
    markDate: {
        type: PropType<MarkDateType[]>;
        default: () => never[];
    };
    disabledDate: {
        type: FunctionConstructor;
        default: () => boolean;
    };
    lang: {
        type: PropType<LangType>;
        default: LangType;
    };
    scrollChangeDate: {
        type: BooleanConstructor;
        default: true;
    };
    calendarTitleHeight: {
        type: NumberConstructor;
        default: number;
    };
    weekStart: {
        type: PropType<WeekStartType>;
        default: WeekStartType;
    };
    disabledScroll: {
        type: PropType<DisabledScrollType>;
        default: () => boolean;
    };
    showNotCurrentMonthDay: {
        type: BooleanConstructor;
        default: true;
    };
    firstDayOfMonthClassName: {
        type: PropType<string>;
        default: string;
    };
    todayClassName: {
        type: PropType<string>;
        default: string;
    };
    checkedDayClassName: {
        type: PropType<string>;
        default: string;
    };
    notCurrentMonthDayClassName: {
        type: PropType<string>;
        default: string;
    };
    disabledClassName: {
        type: PropType<string>;
        default: string;
    };
}, () => JSX.Element, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, ("height" | "update:showWeekView" | "click" | "change" | "slidechange" | "touchstart" | "touchmove" | "touchend")[], "height" | "update:showWeekView" | "click" | "change" | "slidechange" | "touchstart" | "touchmove" | "touchend", import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<ExtractPropTypes<{
    showWeekView: BooleanConstructor;
    show: BooleanConstructor;
    disabledWeekView: BooleanConstructor;
    defaultDate: {
        type: DateConstructor;
        validator: (val: unknown) => val is Date;
        default: Date | null;
    };
    minDate: {
        type: DateConstructor;
        validator: (val: unknown) => val is Date;
        default: Date | null;
    };
    maxDate: {
        type: DateConstructor;
        validator: (val: unknown) => val is Date;
        default: Date | null;
    };
    markType: {
        type: PropType<MarkType>;
        default: MarkType;
    };
    markDate: {
        type: PropType<MarkDateType[]>;
        default: () => never[];
    };
    disabledDate: {
        type: FunctionConstructor;
        default: () => boolean;
    };
    lang: {
        type: PropType<LangType>;
        default: LangType;
    };
    scrollChangeDate: {
        type: BooleanConstructor;
        default: true;
    };
    calendarTitleHeight: {
        type: NumberConstructor;
        default: number;
    };
    weekStart: {
        type: PropType<WeekStartType>;
        default: WeekStartType;
    };
    disabledScroll: {
        type: PropType<DisabledScrollType>;
        default: () => boolean;
    };
    showNotCurrentMonthDay: {
        type: BooleanConstructor;
        default: true;
    };
    firstDayOfMonthClassName: {
        type: PropType<string>;
        default: string;
    };
    todayClassName: {
        type: PropType<string>;
        default: string;
    };
    checkedDayClassName: {
        type: PropType<string>;
        default: string;
    };
    notCurrentMonthDayClassName: {
        type: PropType<string>;
        default: string;
    };
    disabledClassName: {
        type: PropType<string>;
        default: string;
    };
}>> & {
    onHeight?: ((...args: any[]) => any) | undefined;
    "onUpdate:showWeekView"?: ((...args: any[]) => any) | undefined;
    onClick?: ((...args: any[]) => any) | undefined;
    onChange?: ((...args: any[]) => any) | undefined;
    onSlidechange?: ((...args: any[]) => any) | undefined;
    onTouchstart?: ((...args: any[]) => any) | undefined;
    onTouchmove?: ((...args: any[]) => any) | undefined;
    onTouchend?: ((...args: any[]) => any) | undefined;
}, {
    showWeekView: boolean;
    show: boolean;
    disabledWeekView: boolean;
    defaultDate: Date;
    minDate: Date;
    maxDate: Date;
    markType: MarkType;
    markDate: MarkDateType[];
    disabledDate: Function;
    lang: LangType;
    scrollChangeDate: boolean;
    calendarTitleHeight: number;
    weekStart: WeekStartType;
    disabledScroll: DisabledScrollType;
    showNotCurrentMonthDay: boolean;
    firstDayOfMonthClassName: string;
    todayClassName: string;
    checkedDayClassName: string;
    notCurrentMonthDayClassName: string;
    disabledClassName: string;
}>;
export default _default;
