var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var stdin_exports = {};
__export(stdin_exports, {
  daysOfMonth: () => daysOfMonth,
  fillNumber: () => fillNumber,
  formatDate: () => formatDate,
  getDayOfWeek: () => getDayOfWeek,
  pick: () => pick
});
module.exports = __toCommonJS(stdin_exports);
var import__ = require(".");
var import_language = __toESM(require("../language"));
const formatDate = function(time, format, lang = "CN") {
  const languageEntiy = import_language.default[lang] || {};
  format = format || `${languageEntiy.DEFAULT_DATE_FORMAT} ${languageEntiy.DEFAULT_TIME_FORMAT}`;
  const date = time ? new Date(time) : new Date();
  const year = date.getFullYear();
  const month = date.getMonth() + 1;
  const day = date.getDate();
  const hour = date.getHours();
  const min = date.getMinutes();
  const sec = date.getSeconds();
  const preArr = Array.apply(null, Array(10)).map((elem, index) => "0" + index);
  const newTime = format.replace(/YY/g, year + "").replace(/F/g, hour >= 12 ? "pm" : "am").replace(/ss/g, preArr[sec] || sec + "").replace(/mm/g, preArr[min] || min + "").replace(
    /hh/g,
    hour > 12 && format.includes("F") ? hour - 12 + "" : format.includes("F") ? hour + "" : preArr[hour] || hour + ""
  ).replace(/DD/g, preArr[day] || day + "").replace(
    /MM/g,
    lang === "EN" ? languageEntiy.MONTH[month - 1] : preArr[month] || month + ""
  );
  return newTime;
};
const fillNumber = (val) => val > 9 ? val : "0" + val;
const daysOfMonth = (year) => [
  31,
  28 + (0, import__.isLeap)(year),
  31,
  30,
  31,
  30,
  31,
  31,
  30,
  31,
  30,
  31
];
const getDayOfWeek = (year = new Date().getFullYear(), month = new Date().getMonth(), day = 1) => {
  const dayOfMonth = new Date(year, month, day);
  const dayOfWeek = dayOfMonth.getDay();
  return dayOfWeek;
};
function pick(obj, keys, ignoreUndefined) {
  return keys.reduce((ret, key) => {
    if (!ignoreUndefined || obj[key] !== void 0) {
      ret[key] = obj[key];
    }
    return ret;
  }, {});
}
